/* hwp5read.h

   hwp5dump는 한글과컴퓨터의 한글 문서 파일 구조 정의
   공개 정책을 따르는 2차 저작물입니다.  */

#ifndef HWP5READ_H
#define HWP5READ_H

#include "hwp5type.h"

typedef struct hwp5_hwpfile_struct HWP5FILE;

/* path는 파일 경로이고, mode는 fopen에 그대로 전달한다.  */
HWP5FILE *hwp5_open  (const char *path, const char *mode);
void     hwp5_close (HWP5FILE *hfp);

void hwp5_get_version_string(char *str, size_t str_size, HWP5FILE *hfp);

/* stream_path는 복합 파일의 스트림 경로이다.  */
HDRSTREAM *hwp5_alloc_hdrstream (const char *stream_path, HWP5FILE *hfp);
void       hwp5_free_hdrstream  (HDRSTREAM *hdrstream);

/* 태그 아이디가 tag_id와 처음으로 일치하는 레코드를 찾아서 반환한다.
   HDR_NEXT_RECORD를 넣으면 처음부터 차례대로 반환한다.
   레코드를 읽으면 hdrstream의 offset이 증가하면서 다음에 읽을 레코드
   위치를 가리키게 된다.  */
HDR  *hwp5_alloc_hdr (int tag_id, HDRSTREAM *h);
void  hwp5_free_hdr  (HDR *hdr);

CFFSTREAM *hwp5_decompress(const CFFSTREAM *stream);

#endif /* HWP5READ_H */
