#include <stdlib.h>
#include <string.h>
#include "linkedlist.h"

LNode *llist_new_base()
{
	LNode *base = malloc(sizeof(*base));
	if (base == NULL)
		return NULL;
	base->data = base->next = NULL;
	return base;
}

void llist_destroy(LNode *base)
{
	if (base == NULL)
		return;
	llist_destroy_with_function(base, free);
}

void llist_destroy_with_function(LNode *base, LlistDestroyF function)
{
	if (base == NULL)
		return;
	llist_destroy_with_function(base->next, function);
	if (base->data != NULL)
		function(base->data);
	free(base);
}

LNode *llist_prepend_copy(LNode *base, const void *data, size_t data_size)
{
	LNode *n;
	if (base == NULL)
		return NULL;

	n = malloc(sizeof(*n));
	if (n == NULL)
		return NULL;

	n->data = malloc(data_size);
	if (n->data == NULL) {
		free(n);
		return NULL;
	}

	memcpy(n->data, data, data_size);
	n->next = base->next;
	base->next = n;
	return n;
}
