#ifndef UNICODE_ENCODING_H
#define UNICODE_ENCODING_H

#include <inttypes.h>

typedef char     utf8char;
typedef uint16_t utf16char;
typedef uint32_t ucs4char;

/* UCS-4 코드 기준 10FFFF까지만 지원한다.
   num은 배열 요소 개수이다.  src가 널로 끝나는 문자열이거나
   dest의 배열 크기를 걱정하지 않아도 된다면 num에 0을 입력한다.
   dest가 가리키는 공간은 미리 확보돼 있어야 한다.
   src에 널이 없어도 dest 문자열에는 널 문자가 붙는다.  */

void ue_utf16_to_ucs4(const utf16char *src,
                      unsigned int     src_num,
                      ucs4char        *dest,
                      unsigned int     dest_num);

void ue_ucs4_to_utf16(const ucs4char *src,
                      unsigned int    src_num,
                      utf16char      *dest,
                      unsigned int    dest_num);

void ue_utf8_to_ucs4(const utf8char *src,
                     unsigned int    src_num,
                     ucs4char       *dest,
                     unsigned int    dest_num);

void ue_ucs4_to_utf8(const ucs4char *src,
                     unsigned int    src_num,
                     utf8char       *dest,
                     unsigned int    dest_num);

void ue_utf16_to_utf8(const utf16char *src,
                      unsigned int     src_num,
                      utf8char        *dest,
                      unsigned int     dest_num);

void ue_utf8_to_utf16(const utf8char *src,
                      unsigned int    src_num,
                      utf16char      *dest,
                      unsigned int    dest_num);

#endif /* UNICODE_ENCODING_H */
