#include "unicode_encoding.h"
#include "unicode_windows.h"

/* num은 널 문자 포함 배열 요소 개수를 뜻한다.
   입력 문자열 개수를 0으로 주면 직접 센다.
   환경에 따라 작동 방식이 다를 수 있다.
   ue_*는 src에 널 문자가 없어도 dest에 널 문자를 붙이지만
   uw_*가 쓰는 윈도우즈 API 함수는 그렇지 않은 것 같다.  */

void ul_locale_to_utf16(const char *src, unsigned int src_num,
                        utf16char *dest, unsigned int dest_num)
{
#ifdef IN_WINDOWS
    uw_clocale_to_utf16(src, src_num, dest, dest_num);
#else
    ue_utf8_to_utf16(src, src_num, dest, dest_num);
#endif
}

void ul_utf16_to_locale(const utf16char *src, unsigned int src_num,
                        char *dest, unsigned int dest_num)
{
#ifdef IN_WINDOWS
    uw_utf16_to_clocale(src, src_num, dest, dest_num);
#else
    ue_utf16_to_utf8(src, src_num, dest, dest_num);
#endif
}
