#ifndef UNICODE_STRING_H
#define UNICODE_STRING_H

#include "unicode_encoding.h"

/* UCS-4 기준으로 글자 수를 센다. (널 문자 제외한 글자 수)
   num은 str의 배열요소 개수 (0이면 무시) */
unsigned int us_ucs4_len_of_utf16(const utf16char *str, unsigned int num);
unsigned int us_ucs4_len_of_utf8(const utf8char *str, unsigned int num);

/* UTF-16 문자열의 널 문자까지의 배열 요소 개수(널 문자 제외)를 센다.
   max는 문자열이 담긴 배열의 전체 배열 요소 개수,
   또는 널이 없는 문자열을 대비한 제한값 (0이면 무시)
   max가 반환되면 그 문자열에는 널 문자가 없는 것이다.  */
unsigned int us_utf16_len(const utf16char *str, unsigned int max);

char *strdup_from_utf16(const utf16char *str, unsigned int num);
void del_chr_in_str(char *str, char chr);

#endif /* UNICODE_STRING_H */
