#define WINVER 0x0500
#include <windows.h>
#include "unicode_encoding.h"
#include "unicode_windows.h"

/* UTF-16 문자열을 윈도우즈 콘솔 기본 환경 C Locale 문자열로 바꿈
   src_num은 src의 배열요소 수(0이면 스스로 셈),
   dest_num은 dest의 배열요소 수  */
void uw_utf16_to_clocale(const utf16char *src, unsigned int src_num,
                         char *dest, unsigned int dest_num)
{
    int in_num; 
    BOOL flag;

    /* 저 아래 윈도우즈 API 함수는 -1을 기본값으로 받는다. */
    if (src_num == 0)
        in_num = -1;
    else
        in_num = src_num;

    WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS
                        | WC_COMPOSITECHECK | WC_DEFAULTCHAR,
                        src, in_num,
                        dest, dest_num,
                        NULL, &flag);
}

void uw_clocale_to_utf16(const char *src, unsigned int src_num,
                         utf16char *dest, unsigned int dest_num)
{
    int in_num;

    if (src_num == 0)
        in_num = -1;
    else
        in_num = src_num;

    MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,
                        src, in_num,
                        dest, dest_num);
}
